<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 02/28/2009 *
 * ===============                              Last change: 02/28/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : code-functions.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Functions for handling status codes              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen zum Umgang mit Status-Funktionen      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

// Adds a code key/value pair to $GLOBALS
function addCode ($key, $value) {
	$GLOBALS['status_codes'][$key] = $value;
}

// Gets a code from the $GLOBALS registry or triggers an error if not found
function getCode ($key) {
	// Is the key set?
	if (!isCodeSet($key)) {
		// Abort here
		trigger_error(sprintf("%s[%s:] Code %s is not set.",
			__FUNCTION__,
			__LINE__,
			$key
		));
	} // END - if

	// Return it
	return $GLOBALS['status_codes'][$key];
}

// Checks wether a specified status code is set
function isCodeSet ($key) {
	// Simply use isset()
	return (isset($GLOBALS['status_codes'][$key]));
}

// [EOF]
?>
